/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: i2ctest.c 2416 2012-12-27 17:17:28Z roi $
 */
/**
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; COPYRIGHT(c) 2017 STMicroelectronics</center></h2>
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *   3. Neither the name of STMicroelectronics nor the names of its contributors
 *      may be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 */

/* 
 *  X-NUCLEO-IKS01A1ƥȤ
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <sil.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include <target_syssvc.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "device.h"
#include "rtc.h"
#include "monitor.h"
#include "i2ctest.h"

#include "x_nucleo_iks01a1.h"
#include "x_nucleo_iks01a1_accelero.h"
#include "x_nucleo_iks01a1_gyro.h"
#include "x_nucleo_iks01a1_magneto.h"
#include "x_nucleo_iks01a1_humidity.h"
#include "x_nucleo_iks01a1_temperature.h"
#include "x_nucleo_iks01a1_pressure.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

#define I2C_TIMING              0x00B1112E
#define TMsg_MaxLen             192

// Enable sensor masks
#define PRESSURE_SENSOR         0x00000001
#define TEMPERATURE_SENSOR      0x00000002
#define HUMIDITY_SENSOR         0x00000004
#define UV_SENSOR               0x00000008  // for future use
#define ACCELEROMETER_SENSOR    0x00000010
#define GYROSCOPE_SENSOR        0x00000020
#define MAGNETIC_SENSOR         0x00000040

#define STREAMING_MSG_LENGTH    55


/**
 * @brief  Serial message structure definition
 */
typedef struct
{
	uint32_t Len;
	uint8_t Data[TMsg_MaxLen];
} TMsg;

typedef struct displayFloatToInt_s {
	int8_t    sign; /* 0 means positive, 1 means negative*/
	uint32_t  out_int;
	uint32_t  out_dec;
} displayFloatToInt_t;


static ER sensor_i2c_init(SENSOR_I2C_Handle_t *hsi2c);
static ER sensor_i2c_write(SENSOR_I2C_Handle_t *hsi2c, uint8_t Addr, uint8_t Reg, uint8_t* pBuffer, uint16_t Size);
static ER sensor_i2c_read(SENSOR_I2C_Handle_t *hsi2c, uint8_t Addr, uint8_t Reg, uint8_t* pBuffer, uint16_t Size);
static void sensor_int_setup(SENSOR_I2C_Handle_t *hsi2c, uint8_t no);
static int_t log_func(int argc, char **argv);
static int_t act_func(int argc, char **argv);


static SENSOR_I2C_Handle_t HI2C = {
	NULL,
	sensor_i2c_init,
	sensor_i2c_write,
	sensor_i2c_read,
	sensor_int_setup
};

/*
 *  ǥХޥɥơ֥
 */
static const COMMAND_INFO sensor_command_info[] = {
	{"LOG",	log_func},
	{"ACT",	act_func}
};

#define NUM_SENSOR_CMD (sizeof(sensor_command_info)/sizeof(COMMAND_INFO))

static const char sensor_name[] = "SENSOR";
static const char sensor_help[] =
"  Sensor  LOG  (mode)  log  mode\n"
"          ACT  (value) sensor act control\n";

static const uint16_t led_pattern[4] = {
	LED01, LED02, LED03, LED04
};

static COMMAND_LINK sensor_command_link = {
	NULL,
	NUM_SENSOR_CMD,
	sensor_name,
	NULL,
	sensor_help,
	&sensor_command_info[0]
};


volatile uint32_t DataTxPeriod = 1000;	/* TX DATA Period */
volatile uint32_t Sensors_Enabled = 0;	/* Enable Sensor Flag */
volatile uint8_t  DataLoggerMode = 0;	/* DataLogger Flag */

float PRESSURE_Value;					/* Pressure Value */
float HUMIDITY_Value;					/* Humidity Value */
float TEMPERATURE_Value;				/* Temperature Value */
SensorAxes_t ACC_Value;					/* Acceleration Value */
SensorAxes_t GYR_Value;					/* Gyroscope Value */
SensorAxes_t MAG_Value;					/* Magnetometer Value */

void *ACCELERO_handle = NULL;
void *GYRO_handle = NULL;
void *MAGNETO_handle = NULL;
void *HUMIDITY_handle = NULL;
void *TEMPERATURE_handle = NULL;
void *PRESSURE_handle = NULL;

/*
 *  SENSOR I2C
 */
static ER
sensor_i2c_init(SENSOR_I2C_Handle_t *hsi2c)
{
	I2C_Init_t   i2c_initd;
	I2C_Handle_t *hi2c;

	if(hsi2c->i2c_handle == NULL){
		i2c_initd.Timing          = I2C_TIMING;
		i2c_initd.AddressingMode  = I2C_ADDRESSINGMODE_7BIT;
		i2c_initd.DualAddressMode = I2C_DUALADDRESS_DISABLE;
		i2c_initd.GeneralCallMode = I2C_GENERALCALL_DISABLE;
		i2c_initd.NoStretchMode   = I2C_NOSTRETCH_DISABLE;
		i2c_initd.OwnAddress1     = 0x33;
		i2c_initd.OwnAddress2     = 0;
		i2c_initd.semid           = I2CTRS_SEM;
		i2c_initd.semlock         = I2CLOC_SEM;

		if((hi2c = i2c_init(I2C1_PORTID, &i2c_initd)) == NULL){
			/* Initialization Error */
			syslog_0(LOG_ERROR, "## I2C ERROR(1) ##");
			return E_SYS;
		}
		hsi2c->i2c_handle = hi2c;
	}
	return E_OK;
}

/*
 *  SENSOR I2C񤭹
 */
static ER
sensor_i2c_write(SENSOR_I2C_Handle_t *hsi2c, uint8_t Addr, uint8_t Reg, uint8_t* pBuffer, uint16_t Size)
{
	ER ercd = E_OK;

	ercd = i2c_memwrite(hsi2c->i2c_handle, Addr, ( uint16_t )Reg, I2C_MEMADD_SIZE_8BIT, pBuffer, Size);

	/* Check the communication status */
	if(ercd != E_OK ){
		/* Execute user timeout callback */
		i2c_deinit(hsi2c->i2c_handle);
		hsi2c->i2c_handle = NULL;
		hsi2c->si2c_init(hsi2c);
		syslog_1(LOG_ERROR, "## SENSOR_I2C_Write Error(0x%2x) ##", Addr);
	}
	return ercd;
}

/*
 *  SENSOR I2Cɹ
 */
static ER
sensor_i2c_read(SENSOR_I2C_Handle_t *hsi2c, uint8_t Addr, uint8_t Reg, uint8_t* pBuffer, uint16_t Size)
{
	ER ercd = E_OK;

	ercd = i2c_memread(hsi2c->i2c_handle, Addr, ( uint16_t )Reg, I2C_MEMADD_SIZE_8BIT, pBuffer, Size);
	if(ercd != E_OK ){
		/* Execute user timeout callback */
		i2c_deinit(hsi2c->i2c_handle);
		hsi2c->i2c_handle = NULL;
		hsi2c->si2c_init(hsi2c);
		syslog_1(LOG_ERROR, "## SENSOR_I2C_Read Error(0x%2x) ##", Addr);
	}
	return ercd;
}

/*
 *  SENSOR
 */
static void
sensor_int_setup(SENSOR_I2C_Handle_t *hsi2c, uint8_t no)
{
	GPIO_Init_t gpio_init;

	gpio_init.mode      = GPIO_MODE_IT_RISING;
	gpio_init.pull      = GPIO_NOPULL;
	gpio_init.otype     = GPIO_OTYPE_PP;
	gpio_init.speed     = GPIO_SPEED_HIGH;
	gpio_init.alternate = 0;
	if(no == 1){
		exti4_func[EXTI4_BASENO-4] = sense1_int;
	}
	else if(no == 2){
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_IOPENR), RCC_IOPENR_GPIOBEN);
		gpio_setup(TADR_GPIOB_BASE, &gpio_init, 0);
	}
}

/*
 *  LOGꥳޥɴؿ
 */
static int_t log_func(int argc, char **argv)
{
	if(argc >= 2)
		DataLoggerMode = atoi(argv[1]);
	printf("DataLoggerMode(%d)\n", DataLoggerMode);
	return 0;
}

/*
 *  ACTꥳޥɴؿ
 */
static int_t act_func(int argc, char **argv)
{
	int_t    arg1=0;

	if(argc >= 2){
		arg1 = atoi(argv[1]);
		Sensors_Enabled = arg1;
	}
	printf("Sensors_Enabled[%08x]\n", Sensors_Enabled);
	return 0;
}

/**
 * @brief  Splits a float into two integer values.
 * @param  in the float value as input
 * @param  out_value the pointer to the output integer structure
 * @param  dec_prec the decimal precision to be used
 * @retval None
 */
static void floatToInt(float in, displayFloatToInt_t *out_value, int32_t dec_prec)
{
	if(in >= 0.0f){
		out_value->sign = 0;
	}
	else{
		out_value->sign = 1;
		in = -in;
	}

	out_value->out_int = (int32_t)in;
	in = in - (float)(out_value->out_int);
	out_value->out_dec = (int32_t)trunc(in * pow(10, dec_prec));
}

/**
  * @brief  Build an array from the uint32_t (LSB first)
  * @param  Dest destination
  * @param  Source source
  * @param  Len number of bytes
  * @retval None
  */
static void Serialize_s32(uint8_t *Dest, int32_t Source, uint32_t Len)
{
	int i;
	for (i = 0; i < Len; i++){
		Dest[i] = Source & 0xFF;
		Source >>= 8;
	}
}

/**
 * @brief  Handles the time+date getting/sending
 * @param  Msg the time+date part of the stream
 * @retval None
 */
static void RTC_Handler(TMsg *Msg)
{
	struct tm2 timedate;

	if(DataLoggerMode){
		rtc_get_time(&timedate);
	}

	if(DataLoggerMode == 2){
		Msg->Data[3] = (uint8_t)timedate.tm_hour;
		Msg->Data[4] = (uint8_t)timedate.tm_min;
		Msg->Data[5] = (uint8_t)timedate.tm_sec;
		Msg->Data[6] = 0;
	}
	else if(DataLoggerMode == 1){
		syslog_3(LOG_NOTICE, "\nTimeStamp: %d:%d:%d", timedate.tm_hour, timedate.tm_min, timedate.tm_sec);
	}
}

/**
 * @brief  Handles the PRESSURE sensor data getting/sending
 * @param  Msg the PRESSURE part of the stream
 * @retval None
 */
static void Pressure_Sensor_Handler(TMsg *Msg)
{
	uint8_t status = 0;

	if(BSP_PRESSURE_IsInitialized(PRESSURE_handle, &status) == COMPONENT_OK && status == 1){
		BSP_PRESSURE_Get_Press(PRESSURE_handle, &PRESSURE_Value);

		if(DataLoggerMode == 2){
			if(Sensors_Enabled & PRESSURE_SENSOR){
				memcpy(&Msg->Data[7], (void *)&PRESSURE_Value, sizeof(float));
			}
		}
		else if(DataLoggerMode == 1){
			displayFloatToInt_t out_value;
			floatToInt(PRESSURE_Value, &out_value, 2);
			syslog_2(LOG_NOTICE, "PRESS: %d.%02d", (int)out_value.out_int, (int)out_value.out_dec);
		}
	}
}

/**
 * @brief  Handles the HUMIDITY sensor data getting/sending
 * @param  Msg the HUMIDITY part of the stream
 * @retval None
 */
static void Humidity_Sensor_Handler(TMsg *Msg)
{
	uint8_t status = 0;

	if(BSP_HUMIDITY_IsInitialized(HUMIDITY_handle, &status) == COMPONENT_OK && status == 1){
		BSP_HUMIDITY_Get_Hum(HUMIDITY_handle, &HUMIDITY_Value);

		if(DataLoggerMode == 2){
			if(Sensors_Enabled & HUMIDITY_SENSOR){
				memcpy(&Msg->Data[15], (void *)&HUMIDITY_Value, sizeof(float));
			}
		}
		else if(DataLoggerMode == 1){
			displayFloatToInt_t out_value;
			floatToInt(HUMIDITY_Value, &out_value, 2);
			syslog_2(LOG_NOTICE, "HUM: %d.%02d", (int)out_value.out_int, (int)out_value.out_dec);
		}
	}
}

/**
 * @brief  Handles the TEMPERATURE sensor data getting/sending
 * @param  Msg the TEMPERATURE part of the stream
 * @retval None
 */
static void Temperature_Sensor_Handler(TMsg *Msg)
{
	uint8_t status = 0;

	if(BSP_TEMPERATURE_IsInitialized(TEMPERATURE_handle, &status) == COMPONENT_OK && status == 1){
		BSP_TEMPERATURE_Get_Temp(TEMPERATURE_handle, &TEMPERATURE_Value);

		if(DataLoggerMode == 2){
			if(Sensors_Enabled & TEMPERATURE_SENSOR){
				memcpy(&Msg->Data[11], (void *)&TEMPERATURE_Value, sizeof(float));
			}
		}
		else if(DataLoggerMode == 1){
			displayFloatToInt_t out_value;
			floatToInt(TEMPERATURE_Value, &out_value, 2);
			syslog_3(LOG_NOTICE, "TEMP: %c%d.%02d", ((out_value.sign) ? '-' : '+'), (int)out_value.out_int, (int)out_value.out_dec);
		}
	}
}

/**
 * @brief  Handles the ACCELERO axes data getting/sending
 * @param  Msg the ACCELERO part of the stream
 * @retval None
 */
static void Accelero_Sensor_Handler(TMsg *Msg)
{
	uint8_t status = 0;

	if(BSP_ACCELERO_IsInitialized(ACCELERO_handle, &status) == COMPONENT_OK && status == 1){
		BSP_ACCELERO_Get_Axes(ACCELERO_handle, &ACC_Value);

		if(DataLoggerMode == 2){
			if(Sensors_Enabled & ACCELEROMETER_SENSOR){
				Serialize_s32(&Msg->Data[19], ACC_Value.AXIS_X, 4);
				Serialize_s32(&Msg->Data[23], ACC_Value.AXIS_Y, 4);
				Serialize_s32(&Msg->Data[27], ACC_Value.AXIS_Z, 4);
			}
		}
		else if(DataLoggerMode == 1)
			syslog_3(LOG_NOTICE, "ACC_X: %d, ACC_Y: %d, ACC_Z: %d", (int)ACC_Value.AXIS_X, (int)ACC_Value.AXIS_Y, (int)ACC_Value.AXIS_Z);
	}
}

/**
 * @brief  Handles the GYRO axes data getting/sending
 * @param  Msg the GYRO part of the stream
 * @retval None
 */
static void Gyro_Sensor_Handler(TMsg *Msg)
{
	uint8_t status = 0;

	if(BSP_GYRO_IsInitialized(GYRO_handle, &status) == COMPONENT_OK && status == 1){
		BSP_GYRO_Get_Axes(GYRO_handle, &GYR_Value);

		if(DataLoggerMode == 2){
			if(Sensors_Enabled & GYROSCOPE_SENSOR){
				Serialize_s32(&Msg->Data[31], GYR_Value.AXIS_X, 4);
				Serialize_s32(&Msg->Data[35], GYR_Value.AXIS_Y, 4);
				Serialize_s32(&Msg->Data[39], GYR_Value.AXIS_Z, 4);
			}
		}
		else if(DataLoggerMode == 1)
			syslog_3(LOG_NOTICE, "GYR_X: %d, GYR_Y: %d, GYR_Z: %d", (int)GYR_Value.AXIS_X, (int)GYR_Value.AXIS_Y, (int)GYR_Value.AXIS_Z);
	}
}

/*
 * @brief  Handles the MAGNETO axes data getting/sending
 * @param  Msg the MAGNETO part of the stream
 * @retval None
 */
static void Magneto_Sensor_Handler(TMsg *Msg)
{
	uint8_t status = 0;

	if(BSP_MAGNETO_IsInitialized(MAGNETO_handle, &status) == COMPONENT_OK && status == 1){
		BSP_MAGNETO_Get_Axes(MAGNETO_handle, &MAG_Value);

		if(DataLoggerMode == 2){
			if(Sensors_Enabled & MAGNETIC_SENSOR){
				Serialize_s32(&Msg->Data[43], (int32_t)MAG_Value.AXIS_X, 4);
				Serialize_s32(&Msg->Data[47], (int32_t)MAG_Value.AXIS_Y, 4);
				Serialize_s32(&Msg->Data[51], (int32_t)MAG_Value.AXIS_Z, 4);
			}
		}
		else if(DataLoggerMode == 1)
			syslog_3(LOG_NOTICE, "MAG_X: %d, MAG_Y: %d, MAG_Z: %d", (int)MAG_Value.AXIS_X, (int)MAG_Value.AXIS_Y, (int)MAG_Value.AXIS_Z);
	}
}

/*
 *  SW1
 */
void sw_int(void)
{
	syslog_0(LOG_NOTICE, "## sw_int() ##");
}

/*
 *  SENSOR INT1
 */
void sense1_int(void)
{
	syslog_0(LOG_NOTICE, "## sense1_int() ##");
}

/*
 *  SENSOR INT2
 */
void sense2_int(void)
{
	uint32_t istatus = sil_rew_mem((uint32_t *)(TADR_EXTI_BASE+TOFF_EXTI_PR));
	syslog_1(LOG_NOTICE, "## sense2_int[%08x] ##", istatus);
	istatus &= ~(1<<0);
    sil_wrw_mem((uint32_t *)(TADR_EXTI_BASE+TOFF_EXTI_PR), istatus);
}


/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	ER_UINT	ercd;
	TMsg Msg;

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	syslog_0(LOG_NOTICE, "I2C SEND/RECV START");
	Sensor_Drv_Setup(&HI2C);
	setup_command(&sensor_command_link);

	/*
	 *  󥵽
	 */
	BSP_ACCELERO_Init( ACCELERO_SENSORS_AUTO, &ACCELERO_handle );
	BSP_GYRO_Init( GYRO_SENSORS_AUTO, &GYRO_handle );
	BSP_MAGNETO_Init( LIS3MDL_0, &MAGNETO_handle );
	BSP_HUMIDITY_Init( HTS221_H_0, &HUMIDITY_handle );
	BSP_TEMPERATURE_Init( HTS221_T_0, &TEMPERATURE_handle );
	BSP_PRESSURE_Init( PRESSURE_SENSORS_AUTO, &PRESSURE_handle );

	/*
	 *  ͭ
	 */
	BSP_ACCELERO_Sensor_Enable( ACCELERO_handle );
	BSP_GYRO_Sensor_Enable( GYRO_handle );
	BSP_MAGNETO_Sensor_Enable( MAGNETO_handle );
	BSP_HUMIDITY_Sensor_Enable( HUMIDITY_handle );
	BSP_TEMPERATURE_Sensor_Enable( TEMPERATURE_handle );
	BSP_PRESSURE_Sensor_Enable( PRESSURE_handle );

	while(1){
#if 0
		if(UART_ReceivedMSG((TMsg*) &Msg)){
			if (Msg.Data[0] == DEV_ADDR){
				HandleMSG((TMsg*) &Msg);
			}
		}
#endif

		RTC_Handler(&Msg);

		Pressure_Sensor_Handler(&Msg);

		Humidity_Sensor_Handler(&Msg);

		Temperature_Sensor_Handler(&Msg);

		Accelero_Sensor_Handler(&Msg);

		Gyro_Sensor_Handler(&Msg);
		if(DataLoggerMode == 0){
			dly_tsk(100);
		}

		Magneto_Sensor_Handler(&Msg);

#if 0
		if( DataLoggerMode){
			BSP_LED_Toggle(LED2);
		}
		else{
			BSP_LED_Off(LED2);
		}
#endif

		if(DataLoggerMode == 2){
#if 0
			INIT_STREAMING_HEADER(&Msg);
			Msg.Len = STREAMING_MSG_LENGTH;
			UART_SendMsg(&Msg);
#endif
			dly_tsk(DataTxPeriod);
		}
		else{
			dly_tsk(500);
		}
	}

#if 1	/* ROI DEBUG */
	syslog_0(LOG_NOTICE, "## STOP ##");
	slp_tsk();
#endif	/* ROI DEBUG */

	syslog(LOG_NOTICE, "Sample program ends.");
//	SVC_PERROR(ext_ker());
}
