/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: x_nucleo_iks01a1.c 2416 2017-12-26 14:34:41Z roi $
 */
/**
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; COPYRIGHT(c) 2017 STMicroelectronics</center></h2>
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *   3. Neither the name of STMicroelectronics nor the names of its contributors
 *      may be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 */

/* 
 *  X-NUCLEO-IKS01A1 DRIVERץ
 */

#include "x_nucleo_iks01a1.h"

static SENSOR_I2C_Handle_t *hi2c;

/* Link function for sensor peripheral */
void Sensor_Drv_Setup(SENSOR_I2C_Handle_t *hsi2c)
{
	hi2c = hsi2c;
}

/**
 * @brief  Configures sensor I2C interface.
 * @param  None
 * @retval COMPONENT_OK in case of success
 * @retval COMPONENT_ERROR in case of failure
 */
DrvStatusTypeDef Sensor_IO_Init( void )
{
  if(hi2c->si2c_init(hi2c) != E_OK)
	 return COMPONENT_ERROR;
  else
     return COMPONENT_OK;
}

/**
 * @brief  Configures sensor interrupts interface for LSM6DS0 sensor).
 * @param  None
 * @retval COMPONENT_OK in case of success
 * @retval COMPONENT_ERROR in case of failure
 */
DrvStatusTypeDef LSM6DS0_Sensor_IO_ITConfig( void )
{

  /*Not implemented yet*/

  return COMPONENT_OK;
}

/**
 * @brief  Configures sensor interrupts interface for LSM6DS3 sensor.
 * @param  None
 * @retval COMPONENT_OK in case of success
 * @retval COMPONENT_ERROR in case of failure
 */
DrvStatusTypeDef LSM6DS3_Sensor_IO_ITConfig( void )
{
	syslog_0(LOG_NOTICE, "## LSM6DS3_Sensor_IO_ITConfig ##");
	hi2c->si2c_setint(hi2c, 1);
	hi2c->si2c_setint(hi2c, 2);
	return COMPONENT_OK;
}



/**
 * @brief  Configures sensor interrupts interface for LPS22HB sensor.
 * @param  None
 * @retval COMPONENT_OK in case of success
 * @retval COMPONENT_ERROR in case of failure
 */
DrvStatusTypeDef LPS22HB_Sensor_IO_ITConfig( void )
{
	syslog_0(LOG_NOTICE, "## LPS22HB_Sensor_IO_ITConfig ##");
	hi2c->si2c_setint(hi2c, 1);
	return COMPONENT_OK;
}

/**
 * @brief  Writes a buffer to the sensor
 * @param  handle instance handle
 * @param  WriteAddr specifies the internal sensor address register to be written to
 * @param  pBuffer pointer to data buffer
 * @param  nBytesToWrite number of bytes to be written
 * @retval 0 in case of success
 * @retval 1 in case of failure
 */
uint8_t Sensor_IO_Write( void *handle, uint8_t WriteAddr, uint8_t *pBuffer, uint16_t nBytesToWrite )
{
	DrvContextTypeDef *ctx = (DrvContextTypeDef *)handle;
	int i = 0;

	switch(ctx->who_am_i){
	case IKS01A1_LPS22HB_WHO_AM_I:
		/* I2C multi-bytes Write not supported for LPS22HB */
		for(i = 0 ; i < nBytesToWrite ; i++){
			/* call I2C_EXPBD Write data bus function */
			if(hi2c->si2c_write(hi2c,  ctx->address, (WriteAddr + i), &pBuffer[i], 1 ) != E_OK){
				return 1;
			}
		}
		return 0;
	case IKS01A1_LPS25HB_WHO_AM_I:
	case IKS01A1_LIS3MDL_WHO_AM_I:
	case IKS01A1_HTS221_WHO_AM_I:
		if(nBytesToWrite > 1) WriteAddr |= 0x80;  /* Enable I2C multi-bytes Write */
	case IKS01A1_LSM6DS0_WHO_AM_I:
	case IKS01A1_LSM6DS3_WHO_AM_I:
	default:
		/* call I2C_EXPBD Write data bus function */
		if(hi2c->si2c_write(hi2c, ctx->address, WriteAddr, pBuffer, nBytesToWrite) != E_OK){
			return 1;
		}
		else{
			return 0;
		}
		break;
	}
}

/**
 * @brief  Reads a from the sensor to buffer
 * @param  handle instance handle
 * @param  ReadAddr specifies the internal sensor address register to be read from
 * @param  pBuffer pointer to data buffer
 * @param  nBytesToRead number of bytes to be read
 * @retval 0 in case of success
 * @retval 1 in case of failure
 */
uint8_t Sensor_IO_Read( void *handle, uint8_t ReadAddr, uint8_t *pBuffer, uint16_t nBytesToRead )
{
	DrvContextTypeDef *ctx = (DrvContextTypeDef *)handle;
	int i = 0;

	switch(ctx->who_am_i){
	case IKS01A1_LPS22HB_WHO_AM_I:
		/* I2C multi-bytes Read not supported for LPS22HB */
		for(i = 0 ; i < nBytesToRead ; i++){
			/* call I2C_EXPBD Read data bus function */
			if(hi2c->si2c_read(hi2c, ctx->address, (ReadAddr + i), &pBuffer[i], 1 ) != E_OK){
				return 1;
			}
		}
		return 0;

	case IKS01A1_LPS25HB_WHO_AM_I:
	case IKS01A1_LIS3MDL_WHO_AM_I:
	case IKS01A1_HTS221_WHO_AM_I:
		if( nBytesToRead > 1) ReadAddr |= 0x80; /* Enable I2C multi-bytes Read */
	case IKS01A1_LSM6DS0_WHO_AM_I:
	case IKS01A1_LSM6DS3_WHO_AM_I:
	default:
		/* call I2C_EXPBD Read data bus function */
		if(hi2c->si2c_read(hi2c, ctx->address, ReadAddr, pBuffer, nBytesToRead) != E_OK){
			return 1;
		}
		else{
			return 0;
		}
	}
}

